import React__default, { createElement, useRef, useState, useCallback, useEffect, Fragment } from 'react';
import styled from 'styled-components';
import { isMobile, BrowserView, MobileView } from 'react-device-detect';
import { SignJWT } from 'jose';
import { nets, TinyFaceDetectorOptions, detectSingleFace } from 'face-api.js';
import Webcam from 'react-webcam';

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }
  strings.raw = raw;
  return strings;
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var createAuthToken = function createAuthToken() {
  try {
    var secret = new TextEncoder().encode('oljsGtPZWqQEjPcVKOrDBqNLLulfPDrhlvRHoNVRHkqkpjFPZWAOxlFugtYAAopO');
    var alg = 'HS256';
    var timeStamp = new Date().getTime();
    var message = {
      iss: 'jio_rrfl',
      iat: timeStamp.toString()
    };
    return Promise.resolve(new SignJWT(message).setProtectedHeader({
      alg: alg
    }).setExpirationTime('2h').sign(secret)).then(function (jwt) {
      console.log(jwt);
      return jwt;
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
var requestTokenForCheckLiveness = function requestTokenForCheckLiveness(url, token) {
  try {
    var formData = new FormData();
    formData.append('app_id', 'jio_rrfl');
    formData.append('send_token', '1');
    return Promise.resolve(fetch(url, {
      body: formData,
      method: 'POST',
      headers: new Headers({
        Authorization: 'Bearer ' + token
      })
    })).then(function (response) {
      return Promise.resolve(response.json()).then(function (json) {
        console.log(json);
        return json.token;
      });
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
var requestToken = function requestToken(url, expiry) {
  try {
    var formData = new FormData();
    formData.append('expiry_at', expiry);
    formData.append('app_id', 'jio_rrfl');
    formData.append('app_key', 'dmlzaHdhbS1zZWxma3lj');
    formData.append('send_token', '1');
    return Promise.resolve(_catch(function () {
      return Promise.resolve(fetch(url, {
        body: formData,
        method: 'POST'
      })).then(function (response) {
        return Promise.resolve(response.json()).then(function (json) {
          return json.token;
        });
      });
    }, function (error) {
      console.log(error);
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var request = function request(url, payload, method, token) {
  try {
    console.log(url, payload, method, token);
    return Promise.resolve(fetch(url, {
      body: payload,
      method: method,
      headers: new Headers({
        Authorization: 'Bearer ' + token
      })
    })).then(function (response) {
      return Promise.resolve(response.text()).then(function (string) {
        var json = string === '' ? {} : JSON.parse(string);
        return json;
      });
    });
  } catch (e) {
    return Promise.reject(e);
  }
};

var _path, _path2, _path3;
function _extends$1() {
  _extends$1 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function SvgEnabled(props) {
  return /*#__PURE__*/createElement("svg", _extends$1({
    xmlns: "http://www.w3.org/2000/svg",
    width: 200,
    height: 200,
    viewBox: "0 0 150 150"
  }, props), _path || (_path = /*#__PURE__*/createElement("path", {
    d: "M61 3.5c-22.7 5.1-40.8 19-50.5 38.9-6.1 12.4-7.8 19.7-7.9 33.1 0 12.9 1.9 21.7 6.9 32.1 7.3 15.2 19.2 26.9 35 34.5 10 4.9 19.3 6.9 31.5 6.9 12.8 0 21.7-2.1 32.9-7.6 19.8-9.8 34.7-29.1 39.1-50.9 1.7-8.2 1.5-23.6-.4-31.7-6.1-26.1-26.5-47.3-52.5-54.3-8.3-2.3-26.2-2.8-34.1-1zm30.5 7c3.3.8 9.8 3.4 14.5 5.7 12 5.8 24.1 17.9 29.8 29.9 9.4 19.8 9.5 39.5.3 58.4-7.3 14.9-17.8 25.2-32.6 32-19 8.7-37.9 8.4-57-.9C24.4 124.8 10.7 104 9.3 79.4c-.9-16.7 3.5-31.1 14-45 8.1-10.7 23.3-20.7 36.4-23.8 7.9-1.9 24.4-2 31.8-.1z"
  })), _path2 || (_path2 = /*#__PURE__*/createElement("path", {
    d: "M58.5 13.9C37.3 20 22.4 34.4 14.8 56c-2.8 7.9-3.5 25.3-1.4 34.5 4.3 18 17.2 34.4 33.6 42.4 13.8 6.7 27.2 8.5 41.8 5.5 19.1-3.8 35.7-16.5 44.1-33.4 5.5-11.2 7.4-20.7 6.8-33-.9-16.7-6.8-29.9-19-42.2-5.3-5.3-8.8-7.7-16-11.2-5-2.4-11.6-4.9-14.5-5.5-8.1-1.7-24.7-1.2-31.7.8zm25.9 39.7c.9.3 1.6 1.2 1.6 2s.7 1.4 1.6 1.4c3.1 0 8.7 3.4 10.5 6.4 2.5 4.1 2.7 20.1.4 24.7C95.4 94 92.2 95 76 95c-12.4 0-14.9-.3-17.6-1.9C53.8 90.3 52 85.6 52 76c0-11.8 2.8-16.7 10.6-18.6 1.6-.4 3.5-1.6 4.2-2.6 1.1-1.5 2.7-1.8 8.7-1.8 4 0 8 .3 8.9.6z"
  })), _path3 || (_path3 = /*#__PURE__*/createElement("path", {
    d: "M70.4 66.8C61.1 72.7 65.2 87 76.2 87c3.2 0 4.7-.7 7.4-3.4 2.8-2.8 3.4-4.2 3.4-7.5 0-8.5-9.4-13.8-16.6-9.3zm10 4.3c1.7 1.4 2.6 3 2.6 5 0 6.5-8 9.3-11.9 4.3-2.7-3.5-2.6-5.9.4-8.9s5.4-3.1 8.9-.4z"
  })));
}

var _image;
function _extends$2() {
  _extends$2 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$2.apply(this, arguments);
}
function SvgDisabled(props) {
  return /*#__PURE__*/createElement("svg", _extends$2({
    xmlns: "http://www.w3.org/2000/svg",
    width: 80,
    height: 80,
    viewBox: "0 0 150 150"
  }, props), _image || (_image = /*#__PURE__*/createElement("image", {
    width: 150,
    height: 150,
    href: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAJYAAACWCAQAAACWCLlpAAAABGdBTUEAALGPC/xhBQAAACBjSFJN AAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAAmJLR0QA/4ePzL8AAAAHdElN RQfmBAsWMyYQhUzxAAAOjElEQVR42u1db27cNhb/rZONG3ubKCi8CIoFqKRAPxQoopwg8gkycwKP T2D7BLZPYPsEnpzAygksn6AyCvRDgSYi0A/BLgqrDeKujbq7H0RRjxT1b4bSzNj9BYhkipLI37z3 +EiKfMBf+Atd4G+zLkAK7sADkP6vI0ICsHDWZZwpWdyDCw+vSigyIUSCc0SIWDyLEs+ALO7Dxyt4 cKZ4SIIQZwhZ1GfJeySLu/DxGgOrD00Q4AwBS/qoQS9kcQcjbDRWtkkQ4G33lHVOFh9gw7I0lSFB gKMuFbNDsriDEbbgNsgaAjgDECM2XHXhAo0bgghHbNxNjToiizvYxlalCU8Q4Qwh4jYtm2xB/cps Md7g0L5SdkBWLVGBjXaMp22qX5ohwZFtwiyTVUlUggBvWWD5fYOKFjbGvk2VtEoWH+CgxEaFeGMu NnfgwYWLF3BKrFIIIAZHjNjsx3MHA2yVWLQIO7a8f2tkcRfHRqVIMMZR0S5xT7imbssXRYhwblJj 7mELI+M9Y+zYUEhLZPE9o/LFOMJYLaZwTf2p/HegxB0tNQMJNqc3ABbIKpGpgr2oVJbJEeBt4T1m wgJsTidfU5PFRzgoFKzQEnEfGyUqYgMFd5Q72MV2IV+MzWns11RkcQcHBgo0C8FH2G1tmSZBiCOq aiUSv8/2Jn3BFGRxFycFpVLaHu5gGxu9EJVBU34+wHFB7idWx4nJ4h5OC8VQfrXeJEpHjJ1cwozS H2E4yYjYhGTxEY4LBdjMrQb3cTwTojKE2CGlKcpXgvX2fYiJyDJQRewUd3Dc0zhDNQ6xT8p0otmv CZyJCcjiB4V2ZjO3E3wbu1P7ULagtH7V5W6C1mTxY80CEIGeG5mioPJVdHNa0dWSrAJVEdZlUXyc zI1MqWWU1tTQLLWga6nNW/meRlVIqNoztI7zAQ+nXJSbRXiJSLl6nF2rRwvJKpj1MdsUV+ZR/XQc sh1Z2lPNP1xv5tc3JquSqtNOJyNsQbbYhRI3dCQaklXQ9ZwqDycz9ajaQFpYA13P6r36RmRxB+9L qZpXS2VGOV0Re1l3czMDrxISLSxVqbF3AIAlWFdMvceP625uQBY/UH8BrIv0xaMKUOnaREKujOra xVo15AOckD8TvEy7oAtKVYpcGT18p9Su0tDXSBZ3tDZwXVDlGIY+FgceTtMTFmGTpDuoVMU6NVR9 ctGTXxhnoRzSQrExxkr6XvlNlWTxbaWnHrBDcXaw4FQBwIhvi7MdxdDv8tK6VdgszWGI8VLo+TYO Zl1TSxCeu2Z/S52IKslSrdKmNIm3hSrgRLSLEfZJaqkqlpLFfaW3dyh+A0dpGxcdsjbsECFJ3+Ku KXu5ZFH5iSXzsx0stg9fWi7qcznYNWUuIYuPFBOedUAHcz+20B4HqUFnMY5I6oj7xawlBp6/JxIU snXA0EO8LRD1M9eawihZfE9Rtsxtm5+xdbugqkhTfT2jUbL4BaFFDJppHYPbBTlAw0+JZ1mQLYNk 8RGhKpGm/fY4DEXkBp26EAXZMqkhbQmOBON+zVeci47t1FlgoepCqJkKZPERsVcJDsVZ7VjPwsMk WwPV3ypK1gY5Fx+iKQTeVozqZUsji7uKuh2Zbrm1MMnWiGbQJYvSMhZjV/4tGGNogly2Ypnm0NFT nawBOX8jjndDroBcjqgvT8yS4mcpQ8gxewYA3MX7WdehNyTsCQBwBxck9Vn2LZcqWa/Jee9ydR+f lfx70FcRhNKxBAFJHWQnqmRRz13wqfSXOsMDPMFyxfU/cIHfuy8GELAhoOmYHAwkZHE/G8bPM2hz O51R9c8Gc3K/4FMfdGVCQgXnSepC0TKalPA1esDjRnO9T/ooSq50QTGNltIn56F2a6d42CjXEj7r ozCZeJyRtFfpQaqh0gJkLSFVTOt4gIei+ssN77jG/wBc47/d2q8nLDHzkUuWT7KH4tiZEq7iSzzF YyxjuTFVwAMsYxmfYw3/aqi6E2EAACwhE2Ru6q7mb3xFsmci6HdRlgf4El/g/lTPWMJjfNlQfVsj Y+ItSfPTt2bwyKUQkLt4WMYqnk5JVIYlrHVj9H1xjEjai/SNehbIVcue/XKs4gurz/vc8vMASKVT Rh88QJKlTFlH4ujbLsWDDiRhFavWn5lSwxLSofaBXLJckvVcHF/YLsOTToxyB0/1xDHKk7iXk+WR rKEhzQJWW7R7bbBkX14zE39O0hxIW8tIciKOrt0S/KNBnitc4AK/ib9W8AhrWKm96yGW8KfNomY1 j0iaj/C+dhmA+AbLt0vV/Vq5usHP+KCkXOISH/AIz2vuXcJDu/3GjI2EpD022axYHB27ZNVRdYnv Naoy/Ibv8Z+au20P4ogp/ZAkebkaujIxzi/aRLVvdYkfcFN69QbvAKxV3G99xMtpXweLqHrRDX4k VK0IO5XarwzvsNrAelmDK46RFBpP1IH7JFvW1bHsOFSR9TOuxNk9fEXatjVc4idcir9+wrf9k5XI FKfq+yynr3JdSVt1D99obsAKvpHydFlrubpGZ1335shV7SuDot3D17hXyNkbYvrHHJG1UuJcLkvT 3iNZmd/J8yTuzAFZmQta3trlJF6iJ7iGNK9IVthXeXSUt3WP5NkfsyocAJMaujMtz1xjjsi6Kr3S m/JVI5kDm5WpX7n5/k2ePUJPyLzNx3kSi+aArIyAixIJupF+WI8efAaP/jEHZOWt4E/G/iGXCrrW 6HndISUrIimZh3HW9lGTYkXK1iV+0CzXDd5Jv/1en2QlpsQlAFDWnbvdvL1qcO659NEv8T24sFGX +KAMznwlc/WASBw9mlLev43tvv26YpZvGQzvxPkNPhjHtZ729a2DCkeeJbnNCmWiL46x3bdWD/uu 4Xnl9afKuHcRtp1VsQbOJUmxedGAAwDaji1T46rm+hq+LWnt7uHrGqqAa7uFTcTRpbTkZFFz7gGa HbOA69pffwXf4nlhiIbhZQMFtPyhSESZEIhzm0Wp8YRShnanWT82qPQa1gBcCmKbuqCfbKthJI5U oONcsiKS/MKQZgHNq7SCR3jUwlv/1W5B8/lCL09ioSRLn8dQbrGEPzsaj/rV/lhEJI6+TIkBauBj eeaJY2i7DL/jo+1H4sq+XCVi5tQjaRFAyQrzK9wHABbbdh+AC8sf0V53MS6fMeGTtHOAkkWVztdu s4hf8Iu1qfaP+GB32j5F5hnQz/tCoESyjB+hWsMnfLAgX1f4d1dj8hkTfp6U2nT6HXzhy29tWYZV 3MdDrODvEwx7XOEan2y7oTlMHx+LBcC0bxiQBWMDjAGW8KCrj7v/wMcOzL0FBOJIPz4WX5fSH5Yq 3Ws12x1CtlxiQNLC9EDVUFW6zhVxLpEpId1rQKQpkmVaC6Wl3X5kckUXP0sGVPtKle61dvvdwFgc ByRNMqAuoTMuSuxnEd1cwLSATiqhJlma0o3E8Qh3BVlNqRISzdK2V1E4zRfB3s4Ne3RkayzVhc7P 8gAOmk/IguLKc5bcEdnKakl3TAlorIuiA00NenbboXlq6FYhTveF547ZuAMmsg7JuXuHZEtsgI5t uimkGuWiQBZLlH0774pshSkt3FF2G9hXM5n6sTRLLls7uM3I6kzlKtEDNhjIYrFJttjY9pj8HGEs 5wmV7bD0bOYRElW29sTZJm4ncq1Rd9A81DMaydJkS+zayaLi7bcCO3JDtQFJ3S/OnJbtJqk6olk3 wMF3t67rY95LknRycpQMVGrOwoAPROpw1nWzDFmjkh00FVRtRP1e2dAu229xz7w77IJiKFwGda9M oUk6qobAjdvKs73ZffxtHYfSu6J7Gpa6SRVksVAx8wO59enQ/nziTBBmYYuwq3wCsl8W+7AyhoVm 5mWEh4WOX5Eh399e3cnJsE1whsqZKM2gO2T/9EX3uRIM5f72qgpW1Kxm2o6Fasda7p8eLDRduY7o gUt2qsKP1s5xMjXCg08CZSwuXXkIUjUEb1Advq/JhPDQHMqHjfVe+YJARjTkaujkWuPSgCwWaw+R EQHZ3gKORVCqRiQ9qQ+Y3OhTAxZoMpTTdbhQyphgKKkaaYEtN+uD9jWPb3hceHj+2sXYpppGj9XL vCNjClWgTeTMU0XDKV2L4HfRyKx65CAZgrAabb74GZZFMzVEOp03BESqjiejqhVZhYiAwHE2MMhi rCudo/nCPhvKQLu6OWlMVfvQyMWQauRlhjjNswcJvF1d+nq0D7pdfCGNJe3iWLNss0WQOwSG6LGt qJpgcaZBGT2854IgFrN17MzJtFmMIVG/EU6no2qilawswbr21ZaD0zwYGTvEszmwX/t4mU2Rcoef FIJXtqZqAjXMUDCUSuMMcB+7M1PIgHaIuW+IcNYq5n2GickqcUb32R7J4c8gEFuI/XxxDXewi20t R4Jhs4jkOqYgq8QZjbBDi8L7lLAAR8q7B4bIsRGGVcMwVZiKLBHvsEjFWB2a5R62CkprFwnGONLe eWAs2c7kKymnJAsoDTu6j0NaLO5ggK1O4qwEeKtaIO5i1/DjJNhUv4ppCwtkiaHZIg0JjrJwNKQa A2xYoyzAWwSqpJQQBYQYTrs61wpZQMV84rg4W8Id+HiFyeP5hIhwVpQS7mPLuCJkapmyTFal9x7i jbmp5j48vIALr7abFCNGBI7I1JJxByNslbS8U9mpjsgSlS9zFhIEeFv1+3JX3OmTeyIAQFRVWT7C 69IVRiEZb583skThd0u9qwQBznQ7M+F7XPgVNCldaDvogCyghjAAiBDiDNEkHg/34OEV/Mrnx9if xEevRkdkAQ0IA1JFi/ArQm1Ru/okBx4ceGBwGzi4ig9vEx2SBQDcx0ZLdzRSxizcVt2lBEH5lwrT o2OyANFS2fOtymDwuWyjB7JSWHZHKXqgKUVvZKXgDga1xrkp0kYi7IOmFD2TlYG7SNu0djYJAGJE OEdY7Xt1gxmRRcF9pBF+Xggv3peXMqc0wTlQ3WL+hTnD/wEu1sKxWq4XBwAAACV0RVh0ZGF0ZTpj cmVhdGUAMjAyMi0wNC0xMVQxOTo1MTozOCswMzowMMmwMsoAAAAldEVYdGRhdGU6bW9kaWZ5ADIw MjItMDQtMTFUMTk6NTE6MzgrMDM6MDC47Yp2AAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJbWFnZVJl YWR5ccllPAAAAABJRU5ErkJggg=="
  })));
}

var _g, _g2, _g3, _g4, _g5, _g6, _g7, _g8;
function _extends$3() {
  _extends$3 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$3.apply(this, arguments);
}
function SvgLoading(props) {
  return /*#__PURE__*/createElement("svg", _extends$3({
    xmlns: "http://www.w3.org/2000/svg",
    style: {
      margin: "auto",
      background: "#fff"
    },
    width: 200,
    height: 200,
    viewBox: "0 0 100 100",
    preserveAspectRatio: "xMidYMid",
    display: "block"
  }, props), _g || (_g = /*#__PURE__*/createElement("g", {
    transform: "translate(80 50)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.875s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.875s"
  })))), _g2 || (_g2 = /*#__PURE__*/createElement("g", {
    transform: "rotate(45 -50.355 121.569)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.875
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.75s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.75s"
  })))), _g3 || (_g3 = /*#__PURE__*/createElement("g", {
    transform: "rotate(90 -15 65)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.75
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.625s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.625s"
  })))), _g4 || (_g4 = /*#__PURE__*/createElement("g", {
    transform: "rotate(135 -.355 41.569)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.625
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.5s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.5s"
  })))), _g5 || (_g5 = /*#__PURE__*/createElement("g", {
    transform: "rotate(180 10 25)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.5
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.375s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.375s"
  })))), _g6 || (_g6 = /*#__PURE__*/createElement("g", {
    transform: "rotate(-135 20.355 8.431)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.375
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.25s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.25s"
  })))), _g7 || (_g7 = /*#__PURE__*/createElement("g", {
    transform: "rotate(-90 35 -15)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.25
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "-0.125s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "-0.125s"
  })))), _g8 || (_g8 = /*#__PURE__*/createElement("g", {
    transform: "rotate(-45 70.355 -71.569)"
  }, /*#__PURE__*/createElement("circle", {
    r: 6,
    fillOpacity: 0.125
  }, /*#__PURE__*/createElement("animateTransform", {
    attributeName: "transform",
    type: "scale",
    begin: "0s",
    values: "1.5 1.5;1 1",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite"
  }), /*#__PURE__*/createElement("animate", {
    attributeName: "fill-opacity",
    keyTimes: "0;1",
    dur: "1s",
    repeatCount: "indefinite",
    values: "1;0",
    begin: "0s"
  })))));
}

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;
var callLiveness = function callLiveness(url, appId, userId, referenceId, captureType, eyesCheck, storeId, whiteBackground, expiryIn, img, img2, imageType) {
  try {
    console.log('image type:', imageType);
    var formData = new FormData();
    formData.append('image', dataURItoBlob(img2, imageType));
    formData.append('image2', dataURItoBlob(img, imageType));
    formData.append('app_id', appId);
    formData.append('user_id', userId);
    formData.append('referenceId', referenceId);
    formData.append('capture_type', captureType);
    formData.append('eyesCheck', eyesCheck);
    formData.append('store_id', storeId);
    formData.append('whiteBackground', whiteBackground);
    formData.append('sub_type', "Lendee");
    return Promise.resolve(createAuthToken()).then(function (token) {
      console.log(token);
      return Promise.resolve(requestTokenForCheckLiveness(url + '/auth_token', token)).then(function (authToken) {
        return Promise.resolve(request(url + '/check_liveness', formData, 'POST', authToken));
      });
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
var videoConstraints = {
  audio: false,
  video: {
    facingMode: 'user'
  }
};
function frontalFaceCheck(landmarks) {
  if (!landmarks || landmarks.length < 68) {
    return false;
  }
  var leftEyeCenter = {
    x: (landmarks[36].x + landmarks[39].x) / 2,
    y: (landmarks[36].y + landmarks[39].y) / 2
  };
  var rightEyeCenter = {
    x: (landmarks[42].x + landmarks[45].x) / 2,
    y: (landmarks[42].y + landmarks[45].y) / 2
  };
  var faceMiddlePoint = {
    x: (leftEyeCenter.x + rightEyeCenter.x) / 2,
    y: (leftEyeCenter.y + rightEyeCenter.y) / 2
  };
  var ratio = {
    x: (rightEyeCenter.x - landmarks[30].x) / (landmarks[30].x - leftEyeCenter.x),
    y: (landmarks[66].y - landmarks[30].y) / (landmarks[30].y - faceMiddlePoint.y)
  };
  if (ratio.x > 0.75 && ratio.x < 1.33 && ratio.y > 0.56 && ratio.y < 1.56) {
    return true;
  }
  return false;
}
(function polyfillGetUserMedia() {
  if (typeof window === 'undefined') {
    return;
  }
  if (navigator.mediaDevices === undefined) {
    navigator.mediaDevices = {};
  }
  if (navigator.mediaDevices.getUserMedia === undefined) {
    navigator.mediaDevices.getUserMedia = function (constraints) {
      var getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;
      if (!getUserMedia) {
        return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
      }
      return new Promise(function (resolve, reject) {
        getUserMedia.call(navigator, constraints, resolve, reject);
      });
    };
  }
})();
function CheckLiveness(_ref) {
  var resizeImage = function resizeImage(base64, height, width, quality) {
    if (quality === void 0) {
      quality = 1;
    }
    try {
      return Promise.resolve(new Promise(function (resolve, reject) {
        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        var canvasCopy = document.createElement('canvas');
        var copyContext = canvasCopy.getContext('2d');
        var img = new Image();
        img.src = base64;
        img.onload = function () {
          canvasCopy.width = img.width;
          canvasCopy.height = img.height;
          copyContext.drawImage(img, 0, 0);
          canvas.width = width;
          canvas.height = height;
          ctx.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvas.width, canvas.height);
          resolve(canvas.toDataURL('image/jpeg', quality));
        };
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var runFaceDetection = function runFaceDetection() {
    try {
      var _temp3 = function _temp3() {
        if (!stopFaceDetection) {
          setTimeout(runFaceDetection, 100);
        }
      };
      console.log("stopFaceDetection", stopFaceDetection);
      var _temp2 = function () {
        if (!stopFaceDetection) {
          console.log('Calling Detect Face function');
          return Promise.resolve(detectFace()).then(function (detection) {
            console.log('Face detection result: ', detection);
            if (detection) {
              var isFrontal = frontalFaceCheck(detection.landmarks.positions);
              if (isFrontal) {
                setFrontal(true);
              } else {
                setFrontal(false);
              }
            }
          });
        }
      }();
      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(_temp3) : _temp3(_temp2));
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var init = function init() {
    try {
      var isFaceDetectorLoaded = false;
      console.log('In Init function - loading models');
      return Promise.resolve(nets.tinyFaceDetector.loadFromUri('https://www.rocksetta.com/tensorflowjs/saved-models/face-api-js/')).then(function () {
        return Promise.resolve(nets.faceLandmark68TinyNet.loadFromUri('https://www.rocksetta.com/tensorflowjs/saved-models/face-api-js/')).then(function () {
          isFaceDetectorLoaded = true;
          console.log('Starting Face detection');
          setTimeout(runFaceDetection, 500);
          setLoading(false);
          setLoadingText('');
        });
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var startCamera = function startCamera() {
    try {
      var _temp = _catch(function () {
        if (!navigator.mediaDevices || !navigator.mediaDevices.enumerateDevices) {
          console.log('enumerateDevices() not supported.');
        }
        navigator.mediaDevices.enumerateDevices().then(function (devices) {
          devices.forEach(function (device) {
            console.log(device.kind + ': ' + device.label + ' id = ' + device.deviceId);
          });
        }).catch(function (err) {
          console.log(err.name + ': ' + err.message);
        });
        return Promise.resolve(navigator.mediaDevices.getUserMedia(videoConstraints)).then(function (stream) {
          videoStream = stream;
          handleSuccess(stream);
        });
      }, function (e) {
        alert("navigator.getUserMedia error:" + e.toString());
      });
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var detectFace = function detectFace() {
    try {
      var videoEl = document.getElementById('webcam');
      var options = new TinyFaceDetectorOptions();
      return Promise.resolve(detectSingleFace(videoEl, options).withFaceLandmarks(true));
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var url = _ref.url,
    appId = _ref.appId,
    userId = _ref.userId,
    referenceId = _ref.referenceId,
    captureType = _ref.captureType,
    eyesCheck = _ref.eyesCheck,
    storeId = _ref.storeId,
    whiteBackground = _ref.whiteBackground,
    expiryIn = _ref.expiryIn,
    getLivenessResponse = _ref.getLivenessResponse;
  var webcamRef = useRef();
  var _useState = useState(false),
    disabled = _useState[0],
    setDisabled = _useState[1];
  var _useState2 = useState(false),
    frontal = _useState2[0],
    setFrontal = _useState2[1];
  var _useState3 = useState(false),
    loading = _useState3[0],
    setLoading = _useState3[1];
  var _useState4 = useState('Please wait, while the face detector is initializing'),
    loadingText = _useState4[0],
    setLoadingText = _useState4[1];
  var interval;
  var videoStream = null;
  var stopFaceDetection = false;
  var timeStamp = new Date().getTime();
  var capture = useCallback(function () {
    try {
      setLoadingText('Please wait while we process the image');
      setLoading(true);
      stopFaceDetection = true;
      var imageSrc = captureSnapshot();
      return Promise.resolve(resizeImage(imageSrc, 450, 450)).then(function (imageResized) {
        var img = imageResized.split(',')[1];
        var mimeString = imageSrc.split(',')[0].split(':')[1].split(';')[0];
        return Promise.resolve(resizeImage(imageSrc, 224, 224)).then(function (imgStr) {
          var img2 = imgStr.split(',')[1];
          clearInterval(interval);
          return Promise.resolve(callLiveness(url, appId, userId, referenceId, captureType, eyesCheck, storeId, whiteBackground, expiryIn, img, img2, mimeString)).then(function (response) {
            response.livenessImage = img;
            response.livenessImageSmall = img2;
            response.livenessImageType = mimeString;
            getLivenessResponse(response);
            setLoading(false);
            response.status === 'success' && setDisabled(true);
          });
        });
      });
    } catch (e) {
      return Promise.reject(e);
    }
  }, [webcamRef]);
  useEffect(function () {
    return function () {
      clearInterval(interval);
      var timeStampInUseEffect = new Date().getTime();
      var difference = Math.abs(timeStampInUseEffect - timeStamp);
      if (difference > 2000) {
        stopFaceDetection = true;
      }
      console.log("Reached here");
      console.log("Setting stopFaceDetection to true in unmount ", stopFaceDetection);
      if (videoStream) {
        videoStream.getTracks().forEach(function (track) {
          track.stop();
        });
      }
    };
  }, []);
  useEffect(function () {
    console.log("Starting");
    var timeOutVar = setTimeout(function () {
      console.log("stopFaceDetection", stopFaceDetection);
      startCamera();
    }, 0);
    return function () {
      console.log("Cleanup..");
      clearTimeout(timeOutVar);
    };
  }, []);
  function stopCamera() {
    clearInterval(interval);
    stopFaceDetection = true;
    var videoElement = webcamRef.current;
    videoElement.pause();
    videoStream.getTracks().forEach(function (track) {
      track.stop();
    });
  }
  function handleSuccess(stream) {
    var videoElement = webcamRef.current;
    var elementInterval = setInterval(function () {
      if (videoElement === null || videoElement === undefined) {
        console.log('rendering element');
      } else {
        console.log('element rendered');
        videoElement.srcObject = stream;
        setTimeout(function () {
          videoElement.play();
          init();
        }, 500);
        clearInterval(elementInterval);
      }
    }, 100);
  }
  function trimCanvas(c) {
    var ctx = c.getContext('2d');
    var copy = document.createElement('canvas').getContext('2d');
    var pixels = ctx.getImageData(0, 0, c.width, c.height);
    var l = pixels.data.length;
    var i;
    var bound = {
      top: null,
      left: null,
      right: null,
      bottom: null
    };
    var x;
    var y;
    for (i = 0; i < l; i += 4) {
      if (pixels.data[i + 3] !== 0) {
        x = i / 4 % c.width;
        y = ~~(i / 4 / c.width);
        if (bound.top === null) {
          bound.top = y;
        }
        if (bound.left === null) {
          bound.left = x;
        } else if (x < bound.left) {
          bound.left = x;
        }
        if (bound.right === null) {
          bound.right = x;
        } else if (bound.right < x) {
          bound.right = x;
        }
        if (bound.bottom === null) {
          bound.bottom = y;
        } else if (bound.bottom < y) {
          bound.bottom = y;
        }
      }
    }
    var trimHeight = bound.bottom - bound.top;
    var trimWidth = bound.right - bound.left;
    var trimmed = ctx.getImageData(bound.left, bound.top, trimWidth, trimHeight);
    copy.canvas.width = trimWidth;
    copy.canvas.height = trimHeight;
    copy.putImageData(trimmed, 0, 0);
    return copy.canvas;
  }
  function captureSnapshot() {
    var videoElement = webcamRef.current;
    if (videoElement != null) {
      var hiddenCanvas = document.getElementById('hidden-canvas');
      hiddenCanvas.setAttribute('width', videoElement.offsetWidth);
      hiddenCanvas.setAttribute('height', videoElement.videoHeight / (videoElement.videoWidth / videoElement.offsetWidth));
      var ctx = hiddenCanvas.getContext('2d');
      var destWidth = 450;
      var destHeight = 450;
      var sourceWidth = videoElement.videoWidth;
      var sourceHeight = videoElement.videoHeight;
      var ratio = sourceWidth / destWidth;
      ctx.canvas.width = destWidth;
      ctx.canvas.height = destHeight;
      ctx.translate(ctx.canvas.width, 0);
      ctx.scale(-1, 1);
      ctx.drawImage(videoElement, sourceWidth / 2 - destWidth / 2 * ratio, sourceHeight / 2 - destHeight / 2 * ratio, destWidth * ratio, destHeight * ratio, 0, 0, destWidth, destHeight);
      var trimmedCanvas = trimCanvas(hiddenCanvas);
      var imageData = trimmedCanvas.toDataURL('image/jpeg');
      stopFaceDetection = true;
      stopCamera();
      return imageData;
    }
  }
  return /*#__PURE__*/React__default.createElement(Fragment, null, loading ? /*#__PURE__*/React__default.createElement(LoadingContainer, null, /*#__PURE__*/React__default.createElement(SvgLoading, {
    style: {
      width: '50%',
      margin: 'auto'
    }
  }), /*#__PURE__*/React__default.createElement(Text, {
    style: {
      width: '75%',
      fontSize: '1rem',
      marginTop: isMobile ? '-100%' : '-25%',
      marginBottom: '0',
      fontWeight: '400',
      color: '#0e0e0e'
    }
  }, loadingText)) : /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement(BrowserView, null, /*#__PURE__*/React__default.createElement(Container, {
    style: {
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("h1", {
    style: {
      margin: '2% 0 0 0',
      fontSize: '2em',
      textAlign: 'center'
    }
  }, "Face Capture"), /*#__PURE__*/React__default.createElement(Container, {
    style: {
      display: 'flex',
      justifyContent: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("video", {
    id: "webcam",
    playsInline: true,
    autoPlay: true,
    width: "400px",
    height: "400px",
    ref: webcamRef,
    style: {
      maxWidth: '100%',
      display: 'block',
      margin: 'auto',
      borderRadius: '50%',
      marginTop: '2%',
      objectFit: 'cover',
      transform: 'scaleX(-1)',
      border: "3px solid " + (frontal ? 'green' : 'red')
    }
  })), /*#__PURE__*/React__default.createElement("canvas", {
    id: "hidden-canvas",
    style: {
      display: 'none'
    }
  }), /*#__PURE__*/React__default.createElement(Text, {
    style: {
      width: '75%',
      fontSize: '1rem',
      marginBottom: '0',
      fontWeight: '400'
    }
  }, loadingText), /*#__PURE__*/React__default.createElement(Button, {
    disabled: disabled || !frontal,
    onClick: capture
  }, disabled || frontal ? /*#__PURE__*/React__default.createElement(SvgEnabled, {
    style: {
      width: '80px',
      height: '80px',
      pointerEvents: 'auto'
    }
  }) : /*#__PURE__*/React__default.createElement(SvgDisabled, {
    style: {
      width: '80px',
      height: '80px',
      pointerEvents: 'none'
    }
  })))), /*#__PURE__*/React__default.createElement(MobileView, null, /*#__PURE__*/React__default.createElement(MobileContainer, null, /*#__PURE__*/React__default.createElement("h1", {
    style: {
      margin: '10% 0 0 0',
      fontSize: '1.8rem',
      textAlign: 'center'
    }
  }, "Face Capture"), /*#__PURE__*/React__default.createElement("video", {
    id: "webcam",
    playsInline: true,
    autoPlay: true,
    ref: webcamRef,
    style: {
      margin: '5% 0%',
      borderRadius: '50%',
      objectFit: 'cover',
      height: window.screen.height * 0.37,
      width: window.screen.width * 0.8,
      transform: 'scaleX(-1)',
      border: "3px solid " + (frontal ? 'green' : 'red')
    }
  }), /*#__PURE__*/React__default.createElement("canvas", {
    id: "hidden-canvas",
    style: {
      display: 'none'
    }
  }), /*#__PURE__*/React__default.createElement(Text, {
    style: {
      width: '75%',
      fontSize: '1rem',
      marginTop: '2%',
      marginBottom: '0',
      fontWeight: '400'
    }
  }, loadingText), /*#__PURE__*/React__default.createElement(Button, {
    disabled: disabled || !frontal,
    onClick: capture
  }, disabled || frontal ? /*#__PURE__*/React__default.createElement(SvgEnabled, {
    style: {
      width: '80px',
      height: '80px',
      pointerEvents: 'auto'
    }
  }) : /*#__PURE__*/React__default.createElement(SvgDisabled, {
    style: {
      width: '80px',
      height: '80px',
      pointerEvents: 'none'
    }
  }))))));
}
var Container = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["\n  display: grid;\n  place-items: center;\n"])));
var MobileContainer = styled.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["\n  display: grid;\n  place-items: center;\n"])));
var Button = styled.button(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["\n  padding: 10px;\n  margin: 10px;\n  background-color: inherit;\n  border: none;\n  cursor: pointer;\n"])));
var LoadingContainer = styled.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(["\n  display: grid;\n  place-items: center;\n  height: 100vh;\n"])));
var Text = styled.h6(_templateObject5 || (_templateObject5 = _taggedTemplateLiteralLoose(["\n  line-height: 1.5em;\n  // height: 5em;\n  overflow: hidden;\n  text-align: center;\n"])));
function dataURItoBlob(dataURI, imageType) {
  var byteString = atob(dataURI);
  var ab = new ArrayBuffer(byteString.length);
  var ia = new Uint8Array(ab);
  for (var i = 0; i < byteString.length; i++) {
    ia[i] = byteString.charCodeAt(i);
  }
  var bb = new Blob([ab], {
    type: imageType
  });
  return bb;
}

var faceMatch = function faceMatch(url, referenceId, userId, appId, matchType, image, image2, imageType) {
  try {
    var formData = new FormData();
    formData.append('referenceId', referenceId);
    formData.append('user_id', userId);
    formData.append('app_id', appId);
    formData.append('match_type', matchType);
    formData.append('image', dataURItoBlob$1(image, imageType));
    formData.append('image2', dataURItoBlob$1(image2, imageType));
    return Promise.resolve(requestToken(url + '/v2/get_auth_token', '1h')).then(function (token) {
      return Promise.resolve(request(url + '/v1/face_match', formData, 'POST', token));
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
function dataURItoBlob$1(dataURI, imageType) {
  var byteString = atob(dataURI);
  var ab = new ArrayBuffer(byteString.length);
  var ia = new Uint8Array(ab);
  for (var i = 0; i < byteString.length; i++) {
    ia[i] = byteString.charCodeAt(i);
  }
  var bb = new Blob([ab], {
    type: imageType
  });
  return bb;
}

var _path$1, _path2$1;
function _extends$4() {
  _extends$4 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$4.apply(this, arguments);
}
function SvgCam(props) {
  return /*#__PURE__*/createElement("svg", _extends$4({
    xmlns: "http://www.w3.org/2000/svg",
    width: 266.667,
    height: 266.667,
    viewBox: "0 0 200 200"
  }, props), _path$1 || (_path$1 = /*#__PURE__*/createElement("path", {
    d: "M73.3 40c-3.5 1.5-5.4 3.6-10 10.7-3.1 4.8-6.2 9.1-6.7 9.5-.6.4-8.5.8-17.6.8-18.5 0-21.5.8-25.7 7L11 71.3v91.2l2.4 3.6c4.9 7.3.5 6.9 87.1 6.9 87.1 0 82.2.4 87.3-7.3l2.7-4.1v-44.5c0-49.5.1-48.4-6.7-53.3-3.1-2.2-4.5-2.3-21.5-2.8-10-.3-18.3-.7-18.6-1-.2-.3-2.9-4.5-6-9.3C129.5 38 129.5 38 100.5 38c-20.6 0-23.4.2-27.2 2zm52.7 6c1 .5 4.4 5 7.5 10 3.1 5 6.5 9.5 7.5 10 1 .6 9.3 1 18.4 1 18 0 20.8.6 23.2 5.1 1.9 3.7 2.1 85.3.2 89.4-2.6 5.7-.2 5.5-82.3 5.5s-79.7.2-82.3-5.5c-1.7-3.7-1.7-85.3 0-89 2.2-4.8 5.2-5.5 23.3-5.5 9.2 0 17.5-.4 18.5-1 1-.5 4.4-5 7.5-10 3.1-4.9 6.4-9.4 7.3-10 2.2-1.3 48.8-1.3 51.2 0z"
  })), _path2$1 || (_path2$1 = /*#__PURE__*/createElement("path", {
    d: "M94 71.3c-6.1 1.4-13.3 4.8-16.8 8L75 81.4l3.1 3.2 3.2 3.3 3.7-2.5c4.8-3.2 12-5.4 17.6-5.4 6.2 0 15.1 3.6 20 8.2 5 4.6 9.4 12.8 9.4 17.4 0 3.2-.1 3.3-5.1 3.6l-5.1.3 7.6 9.5c4.2 5.2 7.9 9.3 8.3 9.1.5-.3 4.1-4.5 8-9.5l7.3-9.1-5.4-.3-5.4-.3-.6-4.7c-.8-5.7-4.5-14-8.7-19.3C124.3 74 107.8 68.3 94 71.3zM58.8 102.8l-7.8 9.7 5.3.3 5.3.3 1.8 7c5.2 20.4 25.2 33.7 45.1 30 6.2-1.2 14.4-4.7 18.5-8l2.5-2-3.4-3.5c-3-3.1-3.7-3.4-5-2.2-4.9 4.3-10.6 6.1-19.1 6.1-9.4 0-13.6-1.6-20.6-7.7-3.9-3.4-9.4-13.7-9.4-17.6 0-2 .5-2.2 5-2.2 2.8 0 5-.2 5-.5C82 112 67 93 66.6 93c0 0-3.6 4.4-7.8 9.8z"
  })));
}

var _templateObject$1, _templateObject2$1, _templateObject3$1, _templateObject4$1, _templateObject5$1, _templateObject6;
var readDocumentCall = function readDocumentCall(url, appId, referenceId, userId, decision, isBack, expiryIn, docType, documentType, img, img2, type) {
  try {
    var formData = new FormData();
    formData.append('app_id', appId);
    formData.append('referenceId', referenceId);
    formData.append('user_id', userId);
    formData.append('decision', decision);
    formData.append('journey', getJourney(docType));
    formData.append('doc_type', getDocType(docType));
    formData.append('document', documentType);
    formData.append('is_back', isBack);
    formData.append('image', dataURItoBlob$2(img, type));
    formData.append('image2', dataURItoBlob$2(img2, type));
    console.log('Performing Token API call');
    return Promise.resolve(requestToken(url + '/get_auth_token', expiryIn)).then(function (token) {
      console.log('Performing Read Document API call');
      return Promise.resolve(request(url + '/read_document', formData, 'POST', token));
    });
  } catch (e) {
    return Promise.reject(e);
  }
};
var aspectRatios = {
  addhar: 0.625,
  pan: 0.625,
  passport: 0.67,
  voter: 1.2,
  pwd: 1.414,
  others: 1.414
};
var FACING_MODE_USER = 'user';
var FACING_MODE_ENVIRONMENT = 'environment';
(function polyfillGetUserMedia() {
  if (typeof window === 'undefined') {
    return;
  }
  if (navigator.mediaDevices === undefined) {
    navigator.mediaDevices = {};
  }
  if (navigator.mediaDevices.getUserMedia === undefined) {
    navigator.mediaDevices.getUserMedia = function (constraints) {
      var getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia || navigator.mediaDevices.getUserMedia || navigator.mediaDevices.webkitGetUserMedia || navigator.mediaDevices.mozGetUserMedia || navigator.mediaDevices.msGetUserMedia;
      if (!getUserMedia) {
        return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
      }
      return new Promise(function (resolve, reject) {
        getUserMedia.call(navigator, constraints, resolve, reject);
      });
    };
  }
})();
function ReadDocument(_ref) {
  var resizeImage = function resizeImage(base64, height, width) {
    try {
      return Promise.resolve(new Promise(function (resolve, reject) {
        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        var canvasCopy = document.createElement('canvas');
        var copyContext = canvasCopy.getContext('2d');
        var img = new Image();
        img.src = base64;
        img.onload = function () {
          canvasCopy.width = img.width;
          canvasCopy.height = img.height;
          copyContext.drawImage(img, 0, 0);
          canvas.width = width;
          canvas.height = height;
          ctx.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvas.width, canvas.height);
          resolve(canvas.toDataURL());
        };
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var captureSnapshot = function captureSnapshot() {
    try {
      var videoElement = webcamRef.current;
      return Promise.resolve(function () {
        if (videoElement != null) {
          var _temp4 = function _temp4() {
            stopCamera();
            return _imageStr;
          };
          window.removeEventListener('deviceorientation', handleOrientation, true);
          var videoHeight = videoElement.offsetWidth * aspectRatios[docType];
          var hiddenCanvas = document.getElementById('hidden-canvas');
          hiddenCanvas.setAttribute('width', videoElement.offsetWidth);
          hiddenCanvas.setAttribute('height', videoHeight);
          var ctx = hiddenCanvas.getContext('2d');
          var destWidth = videoElement.videoWidth;
          var destHeight = videoElement.videoWidth * aspectRatios[docType];
          var sourceWidth = videoElement.videoWidth;
          var sourceHeight = videoElement.videoHeight;
          var ratio = sourceWidth / destWidth;
          ctx.canvas.width = destWidth;
          ctx.canvas.height = destHeight;
          if (facingMode === FACING_MODE_USER) {
            ctx.translate(ctx.canvas.width, 0);
            ctx.scale(-1, 1);
          }
          if (docType === 'pwd' || docType === 'others') {
            destWidth = destWidth * 0.5;
            destHeight = destWidth * aspectRatios[docType];
            ctx.canvas.width = destWidth;
            ctx.canvas.height = destHeight;
            ctx.drawImage(videoElement, 0, 0, sourceWidth, sourceHeight, 0, 0, destWidth, destHeight);
          } else {
            ctx.drawImage(videoElement, sourceWidth / 2 - destWidth / 2 * ratio, sourceHeight / 2 - destHeight / 2 * ratio, destWidth * ratio, destHeight * ratio, 0, 0, destWidth, destHeight);
          }
          var imageData = hiddenCanvas.toDataURL('image/png');
          var _imageStr;
          var _temp3 = function () {
            if (docType === 'pwd' || docType === 'others') {
              return Promise.resolve(resizeImage(imageData, destHeight, destWidth)).then(function (_resizeImage) {
                _imageStr = _resizeImage;
              });
            } else {
              _imageStr = imageData;
            }
          }();
          return _temp3 && _temp3.then ? _temp3.then(_temp4) : _temp4(_temp3);
        }
      }());
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var url = _ref.url,
    appId = _ref.appId,
    referenceId = _ref.referenceId,
    userId = _ref.userId,
    decision = _ref.decision,
    isBack = _ref.isBack,
    expiryIn = _ref.expiryIn,
    docType = _ref.docType,
    documentType = _ref.documentType,
    getReadDocumentImage = _ref.getReadDocumentImage;
  var webcamRef = useRef();
  var _React$useState = React__default.useState(FACING_MODE_ENVIRONMENT),
    facingMode = _React$useState[0],
    setFacingMode = _React$useState[1];
  var _React$useState2 = React__default.useState(false),
    loading = _React$useState2[0],
    setLoading = _React$useState2[1];
  var _React$useState3 = React__default.useState(false),
    enableCapture = _React$useState3[0],
    setEnableCapture = _React$useState3[1];
  var _React$useState4 = React__default.useState(false),
    cameraAvailable = _React$useState4[0],
    setCameraAvailable = _React$useState4[1];
  var _React$useState5 = React__default.useState(true),
    isOriented = _React$useState5[0],
    setIsOriented = _React$useState5[1];
  var videoConstraints = {
    audio: false,
    video: {
      facingMode: facingMode
    }
  };
  var videoStream = null;
  var camFacingMode = FACING_MODE_ENVIRONMENT;
  var isCameraOpened = false;
  var handleClick = React__default.useCallback(function () {
    try {
      var videoElement = webcamRef.current;
      if (camFacingMode === FACING_MODE_ENVIRONMENT) {
        camFacingMode = FACING_MODE_USER;
      } else {
        camFacingMode = FACING_MODE_ENVIRONMENT;
      }
      setFacingMode(camFacingMode);
      console.log(facingMode);
      var videoTracks = videoStream.getVideoTracks();
      if (videoTracks.length === 0) {
        return Promise.resolve();
      }
      videoTracks.forEach(function (track) {
        track.stop();
      });
      var _temp = _catch(function () {
        return Promise.resolve(navigator.mediaDevices.getUserMedia(videoConstraints)).then(function (_navigator$mediaDevic) {
          videoStream = _navigator$mediaDevic;
          videoElement.srcObject = videoStream;
        });
      }, function (err) {
        console.log(err);
        alert(err.toString());
      });
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  }, []);
  var capture = useCallback(function () {
    try {
      var _temp2 = function _temp2(imgStr) {
        var img = imgStr.split(',')[1];
        var mimeString = imgStr.split(',')[0].split(':')[1].split(';')[0];
        return Promise.resolve(resizeImage(imgStr, 224, 224)).then(function (img2Str) {
          var img2 = img2Str.split(',')[1];
          return Promise.resolve(readDocumentCall(url, appId, referenceId, userId, decision, isBack, expiryIn, docType, documentType, img, img2, mimeString)).then(function (response) {
            response.image = img;
            response.type = mimeString;
            getReadDocumentImage(response);
            setLoading(false);
          });
        });
      };
      setLoading(true);
      return Promise.resolve(isMobile ? Promise.resolve(captureSnapshot()).then(_temp2) : _temp2(webcamRef.current.getScreenshot()));
    } catch (e) {
      return Promise.reject(e);
    }
  }, [webcamRef]);
  useEffect(function () {
    console.log('Vishwam SDK initialized');
    if (typeof DeviceMotionEvent.requestPermission === 'function') {
      DeviceOrientationEvent.requestPermission().then(function (response) {
        console.log(response);
        if (response === 'granted') {
          window.addEventListener('deviceorientation', handleOrientation, true);
          setIsOriented(true);
          initUIandCamera();
        }
      }).catch(function (err) {
        console.log(err);
        setIsOriented(false);
      });
    } else {
      setIsOriented(true);
      initUIandCamera();
      if (typeof DeviceOrientationEvent !== 'undefined') {
        window.addEventListener('deviceorientation', handleOrientation, true);
      } else {
        window.addEventListener('orientationchange', handleOrientationIos, true);
      }
    }
  }, [webcamRef]);
  function startCamera() {
    if (!navigator.mediaDevices || !navigator.mediaDevices.enumerateDevices) {
      console.log('enumerateDevices() not supported.');
    }
    navigator.mediaDevices.enumerateDevices().then(function (devices) {
      devices.forEach(function (device) {
        console.log(device.kind + ': ' + device.label + ' id = ' + device.deviceId);
      });
    }).catch(function (err) {
      console.log(err);
    });
    var supportedConstraints = navigator.mediaDevices.getSupportedConstraints();
    console.log('supported constraints: ', supportedConstraints);
    navigator.mediaDevices.getUserMedia({
      audio: false,
      video: {
        facingMode: facingMode
      }
    }).then(function (stream) {
      webcamRef.current.srcObject = stream;
      videoStream = stream;
      setCameraAvailable(true);
      isCameraOpened = true;
      webcamRef.current.play();
    }).catch(function (err) {
      console.log(err);
      console.log(err.name);
      var errString = err.toString();
      setCameraAvailable(false);
      isCameraOpened = false;
      if (errString.includes('NotReadableError')) {
        setTimeout(function () {
          startCamera();
        }, 1000);
      } else if (err.name === 'NotAllowedError') {
        console.log('Camera Permission denied');
        var errObj = {
          status: 'failed',
          error: err.name,
          message: 'Camera Permission Denied'
        };
        getReadDocumentImage(errObj);
      } else {
        alert("getUserMedia error: " + err.toString());
      }
    });
  }
  function initUIandCamera() {
    setTimeout(function () {
      if (isMobile) {
        var videoElement = webcamRef.current;
        videoElement.style.height = aspectRatios[docType] * videoElement.offsetWidth + 'px';
        videoElement.style.minHeight = aspectRatios[docType] * videoElement.offsetWidth + 'px';
        startCamera();
      }
    }, 500);
  }
  function detectPhoneTilt() {
    console.log('type of DeviceOrientationEvent', typeof DeviceOrientationEvent);
    if (typeof DeviceMotionEvent.requestPermission === 'function') {
      console.log('Requesting device orientation');
      DeviceOrientationEvent.requestPermission().then(function (response) {
        console.log('Device orientation request response', response);
        if (response === 'granted') {
          window.addEventListener('deviceorientation', handleOrientation, true);
          setIsOriented(true);
          initUIandCamera();
        } else {
          alert('Device motion detection rejected');
          var errObj = {
            status: 'Failed',
            error: 'Device motion detection access rejected'
          };
          getReadDocumentImage(errObj);
        }
      }).catch(function (err) {
        console.log('Device orientation request error', err);
        getReadDocumentImage(err);
      });
    } else {
      setIsOriented(true);
      initUIandCamera();
      if (typeof DeviceOrientationEvent !== 'undefined') {
        window.addEventListener('deviceorientation', handleOrientation, true);
      } else {
        window.addEventListener('orientationchange', handleOrientationIos, true);
      }
    }
  }
  function handleOrientation(event) {
    var beta = event.beta;
    var gamma = event.gamma;
    var pitch = 10;
    var roll = 10;
    if (camFacingMode === FACING_MODE_ENVIRONMENT) {
      if (beta > 0 - pitch && beta < pitch && gamma > 0 - roll && gamma < roll) {
        enableDocCapture();
      } else {
        disableDocCapture();
      }
    } else {
      enableDocCapture();
    }
  }
  function handleOrientationIos(event) {
    console.log('Orientation Ios', event);
  }
  function enableDocCapture() {
    console.log('is camera available - ', isCameraOpened);
    if (isCameraOpened) {
      setEnableCapture(true);
    } else {
      setEnableCapture(false);
    }
  }
  function disableDocCapture() {
    setEnableCapture(false);
  }
  function stopCamera() {
    var videoElement = webcamRef.current;
    if (videoElement) {
      videoElement.pause();
    }
    if (videoStream) {
      videoStream.getTracks().forEach(function (track) {
        track.stop();
      });
    }
  }
  return /*#__PURE__*/React__default.createElement(Fragment, null, loading ? /*#__PURE__*/React__default.createElement(LoadingContainer$1, null, /*#__PURE__*/React__default.createElement(SvgLoading, {
    style: {
      width: '50%',
      margin: 'auto'
    }
  }), /*#__PURE__*/React__default.createElement(Text$1, {
    style: {
      width: '50%',
      fontSize: '1rem',
      marginTop: isMobile ? '-100%' : '-25%',
      marginBottom: '0',
      fontWeight: '400',
      color: '#0e0e0e'
    }
  }, "Please wait while we process the image")) : /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement(BrowserView, null, /*#__PURE__*/React__default.createElement(Container$1, null, /*#__PURE__*/React__default.createElement("h1", {
    style: {
      margin: '4% 0 4% 0',
      fontSize: '2em',
      textAlign: 'center'
    }
  }, ' ', "Capture Document", ' '), /*#__PURE__*/React__default.createElement(Webcam, {
    id: "video",
    forceScreenshotSourceSize: true,
    audio: false,
    ref: webcamRef,
    width: isMobile ? screen.width : screen.width / 3,
    screenshotQuality: "1",
    screenshotFormat: "image/jpeg",
    videoConstraints: _extends({}, videoConstraints, {
      facingMode: facingMode
    })
  }), /*#__PURE__*/React__default.createElement(Text$1, {
    style: {
      width: '75%',
      fontSize: '1rem',
      marginTop: '5%',
      marginBottom: '0',
      fontWeight: '400',
      color: "" + (enableCapture ? '#0e0e0e' : '#FF422C')
    }
  }, enableCapture ? 'Make sure your document is without any glare and is fully inside' : 'Hold the phone flat while capturing. Do not tilt the phone while capturing.'), /*#__PURE__*/React__default.createElement(Flex, {
    style: {
      marginTop: '-4%'
    }
  }, /*#__PURE__*/React__default.createElement(Button$1, {
    onClick: capture
  }, /*#__PURE__*/React__default.createElement(SvgEnabled, {
    style: {
      width: '80px',
      height: '80px',
      pointerEvents: 'auto'
    }
  })), /*#__PURE__*/React__default.createElement(Button$1, {
    onClick: handleClick
  }, /*#__PURE__*/React__default.createElement(SvgCam, {
    style: {
      width: '100%',
      height: '80%',
      objectFit: 'cover'
    }
  }))))), /*#__PURE__*/React__default.createElement(MobileView, null, isOriented ? /*#__PURE__*/React__default.createElement(MobileContainer$1, {
    style: {
      width: '100%'
    }
  }, /*#__PURE__*/React__default.createElement("h1", {
    style: {
      margin: '5% 0 0 0',
      fontSize: '1.8rem',
      textAlign: 'center'
    }
  }, ' ', "Capture Document", ' '), /*#__PURE__*/React__default.createElement("video", {
    style: {
      margin: '5% 0 5% 0',
      objectFit: 'cover',
      transform: "" + (facingMode === FACING_MODE_USER ? 'scaleX(-1)' : 'none')
    },
    id: "video",
    ref: webcamRef,
    playsInline: true,
    autoPlay: true,
    width: isMobile ? screen.width * 0.85 : screen.width / 3
  }), /*#__PURE__*/React__default.createElement("canvas", {
    id: "hidden-canvas",
    style: {
      display: 'none'
    }
  }), /*#__PURE__*/React__default.createElement(Text$1, {
    style: {
      width: '75%',
      fontSize: '1rem',
      marginTop: '2%',
      marginBottom: '0',
      fontWeight: '400',
      color: "" + (enableCapture ? '#0e0e0e' : '#FF422C')
    }
  }, enableCapture ? 'Make sure your document is without any glare and is fully inside' : 'Hold the phone flat while capturing. Do not tilt the phone while capturing.'), cameraAvailable ? /*#__PURE__*/React__default.createElement("div", null) : /*#__PURE__*/React__default.createElement(Text$1, {
    style: {
      width: '75%',
      fontSize: '1rem',
      marginTop: '0',
      marginBottom: '0',
      fontWeight: '400',
      color: '#0e0e0e'
    }
  }, "Accessing camera.. Please wait.."), /*#__PURE__*/React__default.createElement("div", {
    id: "capture-container",
    style: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    }
  }, /*#__PURE__*/React__default.createElement(Button$1, {
    onClick: capture,
    disabled: !enableCapture
  }, enableCapture ? /*#__PURE__*/React__default.createElement(SvgEnabled, {
    style: {
      width: '70px',
      height: '70px',
      pointerEvents: 'auto'
    }
  }) : /*#__PURE__*/React__default.createElement(SvgDisabled, {
    style: {
      width: '70px',
      height: '70px',
      pointerEvents: 'none'
    }
  })))) : /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement("div", {
    style: {
      margin: '40% auto 0',
      textAlign: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("h3", null, "Please allow device motion detection to capture document"), /*#__PURE__*/React__default.createElement("button", {
    style: {
      margin: '5% auto 0',
      backgroundColor: '#4a6eff',
      borderColor: '#4a6eff',
      color: '#fff',
      borderRadius: '15px',
      padding: '10px 15px'
    },
    onClick: detectPhoneTilt
  }, "Allow device motion"))))));
}
var Container$1 = styled.div(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteralLoose(["\n  display: grid;\n  place-items: center;\n"])));
var MobileContainer$1 = styled.div(_templateObject2$1 || (_templateObject2$1 = _taggedTemplateLiteralLoose(["\n  display: grid;\n  place-items: center;\n"])));
var Text$1 = styled.h6(_templateObject3$1 || (_templateObject3$1 = _taggedTemplateLiteralLoose(["\n  line-height: 1.5em;\n  height: 5em;\n  overflow: hidden;\n  text-align: center;\n"])));
var Flex = styled.div(_templateObject4$1 || (_templateObject4$1 = _taggedTemplateLiteralLoose(["\n  display: flex;\n  width: 20%;\n"])));
var Button$1 = styled.button(_templateObject5$1 || (_templateObject5$1 = _taggedTemplateLiteralLoose(["\n  padding: 5px;\n  margin: 5px;\n  background-color: inherit;\n  border: none;\n  cursor: pointer;\n"])));
var LoadingContainer$1 = styled.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteralLoose(["\n  display: grid;\n  place-items: center;\n  height: 100vh;\n"])));
function dataURItoBlob$2(dataURI, imageType) {
  var byteString = atob(dataURI);
  var ab = new ArrayBuffer(byteString.length);
  var ia = new Uint8Array(ab);
  for (var i = 0; i < byteString.length; i++) {
    ia[i] = byteString.charCodeAt(i);
  }
  var bb = new Blob([ab], {
    type: imageType
  });
  return bb;
}
function getDocType(docType) {
  switch (docType) {
    case 'addhar':
      return '1';
    case 'pan':
      return '2';
    case 'voter':
      return '4';
    case 'passport':
      return '3';
    case 'pwd':
      return 'pwd';
    case 'others':
      return 'others';
    default:
      return '1';
  }
}
function getJourney(docType) {
  return 'na';
}

export { CheckLiveness, ReadDocument, faceMatch };
//# sourceMappingURL=index.modern.js.map
